package net.t2code.alias.Spigot.config.alias;

import net.t2code.alias.Spigot.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Collections;

public class AliasConfigConverter {
    /**
     * Converter 1.1
     *
     * @param yamlConfiguration
     * @param config_gui
     */

    public static void convertAliasList(YamlConfiguration yamlConfiguration, File config_gui) {
        yamlConfiguration.set("Alias.AliasList", Collections.singletonList(config_gui.getName().replace(".yml", "")));
        try {
            yamlConfiguration.save(config_gui);
        } catch (IOException e) {
            e.printStackTrace();
        }

        T2C_Send.error(Main.getInstance(), "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
        T2C_Send.error(Main.getInstance(), "");
        T2C_Send.warning(Main.getInstance(), "The " + config_gui.getName() + " file is converted to the new config format.");
        T2C_Send.warning(Main.getInstance(), "The alias is no longer the filename, this is now adjustable in the file under 'Alias.AliasList'!");
        T2C_Send.warning(Main.getInstance(), "This allows a function to have multiple alias commands without creating multiple files!");
        T2C_Send.error(Main.getInstance(), "");
        T2C_Send.error(Main.getInstance(), "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");

    }

    public static void convertAddPermission(YamlConfiguration yamlConfiguration, File config_gui, Boolean subalias) {
        if (subalias) {
            yamlConfiguration.set("SubAlias.Permission.Permission", "t2c.alias.sub.use.[alias]");
        } else yamlConfiguration.set("Alias.Permission.Permission", "t2c.alias.use.[alias]");
        try {
            yamlConfiguration.save(config_gui);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void convertAddCooldownInSecGlobal(YamlConfiguration yamlConfiguration, File config_gui, Boolean subalias) {
        if (subalias) {
            yamlConfiguration.set("Alias.CooldownInSec.Global", 0);
        } else yamlConfiguration.set("Alias.CooldownInSec.Global", 0);
        try {
            yamlConfiguration.save(config_gui);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    public static void convertAddCooldownInSecPlayer(YamlConfiguration yamlConfiguration, File config_gui, Boolean subalias) {
        if (subalias) {
            yamlConfiguration.set("Alias.CooldownInSec.Player", 0);
        } else yamlConfiguration.set("Alias.CooldownInSec.Player", 0);
        try {
            yamlConfiguration.save(config_gui);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void convertAddPermissionMSG(YamlConfiguration yamlConfiguration, File config_gui, Boolean subalias) {
        if (subalias) {
            yamlConfiguration.set("SubAlias.Permission.CustomNoPermissionMSG", "");
        } else yamlConfiguration.set("Alias.Permission.CustomNoPermissionMSG", "");
        try {
            yamlConfiguration.save(config_gui);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void convertAddCostConfirm(YamlConfiguration yamlConfiguration, File config_gui, Boolean subalias) {
        if (subalias) {
            yamlConfiguration.set("SubAlias.Cost.Confirm", false);
        } else yamlConfiguration.set("Alias.Cost.Confirm", false);
        try {
            yamlConfiguration.save(config_gui);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
