package net.t2code.alias.Spigot.config.alias;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_Config;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_Config;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;

public class CreateExampleAliasConfig {

    public static void configCreate() {
        long long_ = System.currentTimeMillis();
        T2C_Send.console(Util.getPrefix() + " §4Alias/aliasexample.yml are created...");

        File config = new File(Main.getPath(), "Alias/aliasexample.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        T2C_Config.set("Alias.Enable", true, yamlConfiguration);
        T2C_Config.set("Alias.AliasList", Arrays.asList("aliasexample1","t2caliasexample"),yamlConfiguration);

        T2C_Config.set("Alias.Permission.Necessary", true, yamlConfiguration);
        T2C_Config.set("Alias.Permission.Permission", "t2c.alias.use.[alias]", yamlConfiguration);
        T2C_Config.set("Alias.Permission.CustomNoPermissionMSG", "", yamlConfiguration);

        T2C_Config.set("Alias.CooldownInSec.Global", 0, yamlConfiguration);
        T2C_Config.set("Alias.CooldownInSec.Player", 0, yamlConfiguration);

        T2C_Config.set("Alias.Cost.Enable", false,yamlConfiguration);
        T2C_Config.set("Alias.Cost.Confirm", true,yamlConfiguration);
        T2C_Config.set("Alias.Cost.Price", 0.0,yamlConfiguration);
        T2C_Config.set("Alias.Cost.AllowByPass", true,yamlConfiguration);

        T2C_Config.set("Alias.Command.Enable", false, yamlConfiguration);
        T2C_Config.set("Alias.Command.CommandAsConsole", true, yamlConfiguration);
        T2C_Config.set("Alias.Command.BungeeCommand", false, yamlConfiguration);
        T2C_Config.set("Alias.Command.Commands", Arrays.asList(), yamlConfiguration);

        T2C_Config.set("Alias.Message.Enable", true, yamlConfiguration);
        T2C_Config.set("Alias.Message.Messages", Arrays.asList("<rainbow>This is a test alias</rainbow>", "<color:#d7ff0f>With this you can use several functions such as <color:#ffd6ad>colored text</color>, <click:suggest_command:'/command'><hover:show_text:'<color:#ff745c>Use Command</color>'>clickable texts</hover></click>, <hover:show_text:'<color:#1f66ff>For example Warps</color>'><click:suggest_command:'/warp home'><color:#365eff>shorten commands of other plugins</color></click></hover> and much more.</color>", "<color:#85a0ff><click:open_url:'http://dc.t2code.net'><hover:show_text:'<color:#0887ff>http://dc.t2code.net</color>'>If you have any questions, please contact our support Discord.</hover></click></color>"), yamlConfiguration);

        T2C_Config.set("Alias.Admin.Enable", false, yamlConfiguration);
        T2C_Config.set("Alias.Admin.Permission", "t2c.alias.[alias].admin", yamlConfiguration);

        T2C_Config.set("Alias.Admin.Command.Enable", true, yamlConfiguration);
        T2C_Config.set("Alias.Admin.Command.CommandAsConsole", true, yamlConfiguration);
        T2C_Config.set("Alias.Admin.Command.BungeeCommand", false, yamlConfiguration);
        T2C_Config.set("Alias.Admin.Command.Commands", Collections.singletonList("say hi"), yamlConfiguration);

        T2C_Config.set("Alias.Admin.Message.Enable", false, yamlConfiguration);
        T2C_Config.set("Alias.Admin.Message.Messages", Arrays.asList(), yamlConfiguration);

        T2C_Config.set("Alias.Console.Enable", false, yamlConfiguration);
        T2C_Config.set("Alias.Console.Command.Enable", false, yamlConfiguration);
        T2C_Config.set("Alias.Console.Command.BungeeCommand", false, yamlConfiguration);
        T2C_Config.set("Alias.Console.Command.Commands", Arrays.asList(), yamlConfiguration);
        T2C_Config.set("Alias.Console.Message.Enable", false, yamlConfiguration);
        T2C_Config.set("Alias.Console.Message.Messages", Arrays.asList(), yamlConfiguration);
        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
        T2C_Send.console(Util.getPrefix() + " §2Alias/aliasexample.yml were successfully created." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }
}
