// This class was created by JaTiTV.

package net.t2code.alias.Spigot.config.alias.newConfig;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class AliasConverter {
    private static YamlConfiguration yamlConfiguration;

    public static void convert() {
        File configDeclaration = new File(Main.getPath() + "X_configDeclaration_X.yml");
        if (configDeclaration.exists()) configDeclaration.delete();
        File aliasDeclaration = new File(Main.getPath() + "/Alias/X_aliasDeclaration_X.yml");
        if (aliasDeclaration.exists()) aliasDeclaration.delete();
        File subaliasDeclaration = new File(Main.getPath() + "/SubAlias/X_subAliasDeclaration_X.yml");
        if (subaliasDeclaration.exists()) subaliasDeclaration.delete();

        convertAlias();
        convertSubAlias();


    }

    private static void convertAlias() {
        File f = new File(Main.getPath() + "/Alias/");
        if (!f.exists()) return;

        File[] fileArray = f.listFiles();
        assert fileArray != null;
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {

                yamlConfiguration = YamlConfiguration.loadConfiguration(file);

                setConfig("Alias.Enable", AliasFile.VALUES.aliasEnable);
                setConfig("Alias.AliasList", AliasFile.VALUES.aliasList);
                setConfig("Alias.Permission.Necessary", AliasFile.VALUES.permNecessary);
                setConfig("Alias.Permission.Permission", AliasFile.VALUES.permission);
                setConfig("Alias.Permission.CustomNoPermissionMSG", AliasFile.VALUES.permissionMSG);
                setConfig("Alias.CooldownInSec.Global", AliasFile.VALUES.cooldownGlobal);
                setConfig("Alias.CooldownInSec.Player", AliasFile.VALUES.cooldownPlayer);
                setConfig("Alias.Cost.Enable", AliasFile.VALUES.costEnable);
                setConfig("Alias.Cost.Confirm", AliasFile.VALUES.costConfirm);
                setConfig("Alias.Cost.Price", AliasFile.VALUES.costPrice);
                setConfig("Alias.Cost.AllowByPass", AliasFile.VALUES.costAllowBypass);
                setConfig("Alias.Command.Enable", AliasFile.VALUES.commandEnable);
                setConfig("Alias.Command.CommandAsConsole", AliasFile.VALUES.commandAsConsole);
                setConfig("Alias.Command.BungeeCommand", AliasFile.VALUES.bungeeCommand);
                setConfig("Alias.Command.Commands", AliasFile.VALUES.command);
                setConfig("Alias.Message.Enable", AliasFile.VALUES.messageEnable);
                setConfig("Alias.Message.Messages", AliasFile.VALUES.messages);
                setConfig("Alias.Admin.Enable", AliasFile.VALUES.adminEnable);
                setConfig("Alias.Admin.Permission", AliasFile.VALUES.adminPermission);
                setConfig("Alias.Admin.Command.Enable", AliasFile.VALUES.adminCommandEnable);
                setConfig("Alias.Admin.Command.CommandAsConsole", AliasFile.VALUES.adminCommandAsConsole);
                setConfig("Alias.Admin.Command.BungeeCommand", AliasFile.VALUES.adminBungeeCommand);
                setConfig("Alias.Admin.Command.Commands", AliasFile.VALUES.adminCommands);
                setConfig("Alias.Admin.Message.Enable", AliasFile.VALUES.adminMessageEnable);
                setConfig("Alias.Admin.Message.Messages", AliasFile.VALUES.adminMessages);
                setConfig("Alias.Console.Enable", AliasFile.VALUES.consoleEnable);
                setConfig("Alias.Console.Command.Enable", AliasFile.VALUES.consoleCommandEnable);
                setConfig("Alias.Console.Command.BungeeCommand", AliasFile.VALUES.consoleBungeeCommand);
                setConfig("Alias.Console.Command.Commands", AliasFile.VALUES.consoleCommands);
                setConfig("Alias.Console.Message.Enable", AliasFile.VALUES.consoleMessageEnable);
                setConfig("Alias.Console.Message.Messages", AliasFile.VALUES.consoleMessages);

                T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "alias/" + file.getName()), AliasFile.VALUES.values(), false, Util.getConfigLogo());
            }
        }
        if (f.renameTo(new File(Main.getPath() + "/OldConfig/Alias/"))) {
            T2C_Send.sendStartTextCenter(Util.getPrefix(), "§4Die Alias Dateien im Ordner plugins/T2C-Alias/Alias", false);
            T2C_Send.sendStartTextCenter(Util.getPrefix(), "§4wurden in den neuen Ordner plugins/T2C-Alias/alias konvertiert!", false);
            T2C_Send.sendStartTextCenter(Util.getPrefix(), "§4Die alten dateien wurden in plugins/T2C-Alias/OldConfig/Alias verschoben.", false);
        }
    }

    private static void convertSubAlias() {
    }

    private static void setConfig(String path, T2C_ConfigItem item) {
        if (yamlConfiguration.contains(path)) {
            item.setValue(yamlConfiguration.get(path));
        }
    }
}
