package net.t2code.alias.Spigot.system;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.cmdManagement.RegisterCommands;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import org.bukkit.command.Command;
import org.bukkit.command.CommandMap;
import org.bukkit.plugin.SimplePluginManager;

import java.lang.reflect.Field;
import java.util.Map;
import java.util.Objects;

public class AliasRegister {
    private Main main;

    public AliasRegister(Main main) {
        this.main = main;
        loadAliasCommands();
    }

    private void loadAliasCommands() {
        CommandMap commandMap = getCommandMap();
        unregister(commandMap);
        if (commandMap == null) {
            main.getLogger().severe("CommandMap konnte nicht geladen werden!");
            return;
        }

        for (String alias : Main.allAliases) {
            if (Main.aliasHashMap.get(alias).aliasEnable){

            // Registrieren des Befehls
System.out.println("Alias: " +alias);
            commandMap.register(main.getDescription().getName(), new RegisterCommands(alias));
            T2C_Send.console(Util.getPrefix() + " §aAlias §e" + alias + " §aregister");

                Main.loadAliasHashMap.put(alias, true);
            } else Main.loadAliasHashMap.put(alias, false);
        }
    }

    private CommandMap getCommandMap() {
        if (main.getServer().getPluginManager() instanceof SimplePluginManager) {
            SimplePluginManager manager = (SimplePluginManager) main.getServer().getPluginManager();
            try {
                Field field = SimplePluginManager.class.getDeclaredField("commandMap");
                field.setAccessible(true);
                return (CommandMap) field.get(manager);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return null;
    }



    private void unregister(CommandMap commandMap) {
        if (commandMap == null) return;
        for (Map.Entry<String, Boolean> entry : Main.loadAliasHashMap.entrySet()) {
            if (entry.getValue()){
                Objects.requireNonNull(commandMap.getCommand(entry.getKey())).unregister(commandMap);
            }
        }
        Main.loadAliasHashMap.clear();
    }


}
